import request from "@/utils/request";
import config from "@/utils/config";
const prefix = config.basePrefix

export const userLogin = ({username, password, key, keyCode, grant_type}) => request({
  url: prefix + '/auth/token',
  method: 'post',
  headers: {'Captcha-Key': key, 'Captcha-Code': keyCode,},
  params: {
    username,
    password,
    grant_type: grant_type ? grant_type : config.captchaMode ? 'captcha' : 'password',
    scope: 'all',
  },
})
export const userLogout = () => request({
  url: prefix + '/auth/logout',
  method: 'get',
})
export const getCaptcha = () =>
  request({url: prefix + '/auth/captcha', method: 'get',});