import type { App } from 'vue';

export function debounce(app: App) {
	app.directive('debounce', {
		mounted(el, binding) {
			let debounceTime = binding.value; // 防抖时间
			if (!debounceTime) {
				// 用户若不设置防抖时间，则默认2s
				debounceTime = 2000;
			}
			let cbFun: any;
			el.addEventListener(
				'click',
				(event: Event) => {
					if (!cbFun) {
						// 第一次执行
						cbFun = setTimeout(() => {
							cbFun = null;
						}, debounceTime);
					} else {
						event && event.stopImmediatePropagation();
					}
				},
				true
			);
		},
	});
}
