import {wavesDirective, dragDirective} from '/@/directives/customDirective';
import {debounce} from '/@/directives/debounce';
import mgmtHelper from 'mgmt-helper'
import createSticky from './sticky'

/**
 * 导出指令方法：v-xxx
 * @methods wavesDirective 按钮波浪指令，用法：v-waves
 * @methods dragDirective 自定义拖动指令，用法：v-drag
 */
export function directive(app) {
  // 按钮波浪指令
  wavesDirective(app);
  // 自定义拖动指令
  dragDirective(app);
  debounce(app);
  app.directive('sticky', createSticky)
  app.directive('auth', {
    mounted(el, binding,) {
      let {value} = binding
      if (!Array.isArray(value)) value = [value]
      value = value.map(i => i + '')
      const permissions = window.__routesCache__.permissions || []
      const hasPermissions = mgmtHelper.hasAuth(value, permissions)
      if (!hasPermissions) {
        el.parentNode && el.parentNode.removeChild(el)
      }
    },
  })
}
